'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* usage
 import Msg from './ReactDialogBoxes';


 <Msg ref={msg => {this.msg = msg;}}/>


 this.msg.alert('header', 'text' [,'buttonText']).then(() => {
     // code
 });

 this.msg.confirm('header', 'text' [, 'okButtonText', 'cancelButtonText']).then(result => {
     // code
 });

 this.msg.prompt(
     text: '',
     [promptPlaceholder: '',]
     [okButtonText: '',]
     [cancelButtonText: '']
 ).then(result => {
        // code
 });
 */

var ReactDialogBoxes = function (_React$Component) {
    _inherits(ReactDialogBoxes, _React$Component);

    function ReactDialogBoxes(props) {
        _classCallCheck(this, ReactDialogBoxes);

        var _this = _possibleConstructorReturn(this, (ReactDialogBoxes.__proto__ || Object.getPrototypeOf(ReactDialogBoxes)).call(this, props));

        _this._defaultOkButtonText = 'Ok';
        _this._defaultCancelButtonText = 'Cancel';
        _this._defaultLoaderText = 'Loading...';

        _this.state = {
            type: 'alert', // other types: confirm, prompt, loader
            isVisible: false,
            messageText: 'Hello!',
            sendData: null,
            okButtonText: _this._defaultOkButtonText,
            cancelButtonText: _this._defaultCancelButtonText,
            promptValue: ''
        };

        _this.alert = _this.alert.bind(_this);
        _this.confirm = _this.confirm.bind(_this);
        _this.prompt = _this.prompt.bind(_this);
        _this._okHandler = _this._okHandler.bind(_this);
        _this._cancelHandler = _this._cancelHandler.bind(_this);
        _this._promptHandler = _this._promptHandler.bind(_this);
        _this.showLoader = _this.showLoader.bind(_this);
        _this.hideLoader = _this.hideLoader.bind(_this);
        return _this;
    }

    _createClass(ReactDialogBoxes, [{
        key: 'alert',
        value: function alert(text, okButtonText) {
            var _this2 = this;

            this.setState({
                type: 'alert',
                isVisible: true,
                messageText: text,
                okButtonText: okButtonText || this._defaultOkButtonText
            });

            return new Promise(function (res, rej) {
                _this2.setState({
                    sendData: res
                });
            });
        }
    }, {
        key: 'confirm',
        value: function confirm(text, okButtonText, cancelButtonText) {
            var _this3 = this;

            this.setState({
                type: 'confirm',
                isVisible: true,
                messageText: text,
                okButtonText: okButtonText || this._defaultOkButtonText,
                cancelButtonText: cancelButtonText || this._defaultCancelButtonText
            });

            return new Promise(function (res, rej) {
                _this3.setState({
                    sendData: res
                });
            });
        }
    }, {
        key: 'prompt',
        value: function prompt(text, okButtonText, cancelButtonText, promptPlaceholder) {
            var _this4 = this;

            this.setState({
                type: 'prompt',
                isVisible: true,
                messageText: text,
                okButtonText: okButtonText || this._defaultOkButtonText,
                cancelButtonText: cancelButtonText || this._defaultCancelButtonText,
                promptPlaceholder: promptPlaceholder || ''
            });

            return new Promise(function (res, rej) {
                _this4.setState({
                    sendData: res
                });
            });
        }
    }, {
        key: '_okHandler',
        value: function _okHandler() {
            this.setState({
                isVisible: false,
                okButtonText: this._defaultOkButtonText
            });
            if (this.state.type === 'prompt') {
                this.state.sendData(this.state.promptValue);
            } else {
                this.state.sendData(true);
            }
        }
    }, {
        key: '_cancelHandler',
        value: function _cancelHandler() {
            this.setState({
                isVisible: false,
                okButtonText: this._defaultOkButtonText,
                cancelButtonText: this._defaultCancelButtonText
            });
            this.state.sendData(false);
        }
    }, {
        key: '_promptHandler',
        value: function _promptHandler(ev) {
            this.setState({
                promptValue: ev.target.value
            });
        }
    }, {
        key: 'showLoader',
        value: function showLoader(loaderText) {
            this.setState({
                type: 'loader',
                isVisible: true,
                messageText: loaderText || this._defaultLoaderText
            });
        }
    }, {
        key: 'hideLoader',
        value: function hideLoader() {
            this.setState({
                type: 'loader',
                isVisible: false,
                messageText: ''
            });
        }
    }, {
        key: '_renderAlertButtons',
        value: function _renderAlertButtons() {
            return _react2.default.createElement(
                'button',
                { className: '_okButton',
                    onClick: this._okHandler
                },
                this.state.okButtonText
            );
        }
    }, {
        key: '_renderConfirmButtons',
        value: function _renderConfirmButtons() {
            return _react2.default.createElement(
                'div',
                { className: '_confirmButtons' },
                _react2.default.createElement(
                    'button',
                    { className: '_okButton',
                        onClick: this._okHandler
                    },
                    this.state.okButtonText
                ),
                _react2.default.createElement(
                    'button',
                    { className: '_cancelButton',
                        onClick: this._cancelHandler
                    },
                    this.state.cancelButtonText
                )
            );
        }
    }, {
        key: '_renderPrompt',
        value: function _renderPrompt() {
            return _react2.default.createElement(
                'div',
                { className: '_promptWrapper' },
                _react2.default.createElement(
                    'div',
                    { className: '_prompt' },
                    _react2.default.createElement('input', { type: 'text',
                        className: '_promptInput',
                        placeholder: this.state.promptPlaceholder,
                        onChange: this._promptHandler,
                        value: this.promptValue
                    })
                ),
                _react2.default.createElement(
                    'button',
                    { className: '_okButton',
                        onClick: this._okHandler
                    },
                    this.state.okButtonText
                ),
                _react2.default.createElement(
                    'button',
                    { className: '_cancelButton',
                        onClick: this._cancelHandler
                    },
                    this.state.cancelButtonText
                )
            );
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                'div',
                { className: 'ReactDialogBoxes' },
                this.state.isVisible && _react2.default.createElement(
                    'div',
                    { className: '_container' },
                    _react2.default.createElement('div', { className: '_background' }),
                    _react2.default.createElement(
                        'div',
                        { className: '_message' },
                        this.state.messageText && _react2.default.createElement(
                            'p',
                            { className: '_text' },
                            this.state.messageText
                        ),
                        this.state.type === 'alert' && this._renderAlertButtons(),
                        this.state.type === 'confirm' && this._renderConfirmButtons(),
                        this.state.type === 'prompt' && this._renderPrompt()
                    )
                )
            );
        }
    }]);

    return ReactDialogBoxes;
}(_react2.default.Component);

exports.default = ReactDialogBoxes;
